namespace dislin { 
#include "C:\Programme\dislin\dislin.h"
               }
#include <math.h>
#include <stdio.h>

	const int N = 2;	// Anzahl der Solitonen (nderbar)
	const double pi = 3.141592654; // Pi, falls fr andere Startbedingungen bentigt

	const double tmax = 10;				//Maximale Berechnungszeit  (nderbar)
	const double dt =  0.0005;	// Zeitauflsung  gutes Ergebnis:  const double dt = 0.000005; schnelles Ergebnis: const double dt = 0.0005 Stabilitt dt = 0,000513
	

	const int xschritte = 200;		// Anzahl der Gitterpunkte in x-Richtung (nderbar)
	const double dx =   0.11;  // Abstand der Gitterpunkte in x-Richtung	gutes Ergebnis: const double dx = 0.03;  schnelles Ergebnis: dx = 0.11 Stabilitt dx = 0.11
	const double xmax = xschritte * dx; // Maximales x fr Dislingraph	

double sech(double x); // Definiert Sekans Hyperbolicus
double Startbedingungen(double xposition, int solitonenzahl); // Funktion fr die Startbedingungen
double ersterzeitschritt(double uxt[xschritte], int i);					
double zeitschritt(double uxt[xschritte], double uxtmdt[xschritte], int i);	// Funktionen fr die Zeitschritte
double analytisch(double Zeit, double Ort); // Funktion fr analytische Lsung

void dislinini(double xmax, double Solitonenzahl);  // Funktion fr Dislininitialisierung


void main()

{	
	dislinini(xmax, N);   // Dislin einleiten und Geometrien festlegen, abhngig von der Anzahl der Solitonen (Hhenanpassung)

	// Gitter fr die Berechnung
	double uxt[xschritte];		// gegenwart t
	double uxtmdt[xschritte];	// vergangenheit -dt
	double uxtpdt[xschritte];	// Zukunft +dt


	int i = 0;   // Zhlvariable
	double t = 0; // Aktuelle Zeit

	char zeitangabe[18];
	char energieangabe[25];			// Variablen fr Ausgabe von Masse, Zeit und energie
	char masseangabe[25];
	double energie = 0;
	double masse = 0;
	double energiemdt = 0;
	double massemdt = 0;

	// Die Startbedingungen fr das komplette Gitter festlegen
			while(i < xschritte)
	{
		uxt[i] = Startbedingungen(i*dx-xmax/2,N);
		i++;
	}
	i = 0;
	


  // erste Berechnung von t+dt mit schlechtem Verfahren (es gibt noch keine zwei Zeitschritte)
	while(i < xschritte)  
	{
	uxtpdt[i] = ersterzeitschritt(uxt, i);
	i++;
	}
	i = 0;

	//umschreiben: Vergangenheit-Gegenwart-Zukunft, so braucht man nur 3 Gitter
 while(i < xschritte)
 {
	 uxtmdt[i] = uxt[i];
	 i++;
 }
 i= 0;

  while(i < xschritte)
 {
	 uxt[i] = uxtpdt[i];
	 i++;
 }
 i= 0;







// weitere Berechnungen mit gutem Verfahren bis zur Zeit tmax

 while(t < tmax)
 {

				
		// berechnet den nchsten Schritt

		 while(i < xschritte)
		 {
			uxtpdt[i] = zeitschritt(uxt,uxtmdt,i);
			i++;
		}
	i = 0;

 				//umschreiben: Vergangenheit-Gegenwart-Zukunft
		while(i < xschritte)
		{
			uxtmdt[i] = uxt[i];
			 i++;
		}
	 i= 0;

	  while(i < xschritte)
		{
		 uxt[i] = uxtpdt[i];
		 i++;
		}
	i= 0;


	

			// berschreibt die bisherige Ausgabe mit weiem Hintergrund ("black" wegen "reverse"), sodass eine Live-Ausgabe mglich ist
	dislin::color("black");
	dislin::hsymbl(5000); // groer weier Punkt
	dislin::rlsymb(21,0,0);


	sprintf_s(zeitangabe, "Zeit t =  %.4f",t-dt);  //schreibt den die Variable t in einen String zur Ausgabe mit dislin
	dislin::rlmess(zeitangabe,-xmax/2,N);		// Textausgabe

	if(abs(massemdt) > 100)			// Falls die Zahlen zu lange werden auf wissenschaftliche Ausgabe umschreiben, sonst buffer overflow - Gefahr
		{
			sprintf_s(masseangabe, "Masse =  %.4E",massemdt);
		}
	else
		{
			sprintf_s(masseangabe, "Masse =  %.4f",massemdt);
		}
	dislin::rlmess(masseangabe,0,N);	// analog fr Masse

	if(abs(energiemdt) > 100)
	{
	sprintf_s(energieangabe, "Energie = %.4E",energiemdt);
	}
	else
	{
	sprintf_s(energieangabe, "Energie = %.4f",energiemdt);
	}
	dislin::rlmess(energieangabe,xmax/3,N);
	
			// Ende des berschreibens der "alten" Ausgabe

	// Tatschliche Ausgabe, schwarze Punkte auf die berrechneten Gitterpunkte

	dislin::color("white");
	dislin::hsymbl(10);
  
	sprintf_s(zeitangabe, "Zeit t =  %.4f",t);
	dislin::rlmess(zeitangabe,-xmax/2,N);

	if(abs(masse) > 100)
		{
			sprintf_s(masseangabe, "Masse =  %.4E",masse);  // siehe oben
		}
	else
		{
			sprintf_s(masseangabe, "Masse =  %.4f",masse);
		}
	dislin::rlmess(masseangabe,0,N);

	if(abs(energie) > 100)
	{
	sprintf_s(energieangabe, "Energie = %.4E",energie);
	}
	else
	{
	sprintf_s(energieangabe, "Energie = %.4f",energie);
	}

	dislin::rlmess(energieangabe,xmax/3,N);

	while(i < xschritte)     
	{
		dislin::rlsymb(21,i*dx-xmax/2,uxt[i]);
		i++;
	}

	
	i = 0;
	dislin::sendbf();  // Dieser Befehl sendet den Buffer direkt auf den Schirm (Live-Ausgabe)
 
	massemdt = masse;
	masse = 0;
	while(i < xschritte)
	{
		masse = masse + uxt[i]*dx;  // Berechnung der Masse (Summe der Amplituden)
		i++;
	}
	masse = masse / xmax;
	i = 0;

	energiemdt = energie;
	
	energie = 0;
	while(i < xschritte)
	{
		energie = energie + uxt[i]*uxt[i]*dx;		// Berechnung der Energie (Summe der Amplitudenquadrate)
		i++;
	}
	

	energie = energie / xmax;
	i = 0;

	t = t + dt;    // nchster Zeitschritt


/*
 //Vergleich mit analytischer lsung
	double uxtanalytisch[xschritte];		// Gitter fr analytische lsung

	while( i < xschritte)
	{
		uxtanalytisch[i] = analytisch(t-dt,i*dx -xmax/2);
		i++;
	}
	i= 0;



		dislin::color("red");
		dislin::hsymbl(10);
	while(i < xschritte)    
	{
		dislin::rlsymb(21,i*dx-xmax/2,uxtanalytisch[i]);
		i++;
	}
		dislin::hsymbl(10);

	
	dislin::sendbf();

	i = 0;

	// Ende analytische Lsung
*/  

 }
// ende der berechnung und ausgabefunktion


 

	dislin::disfin();
}

// main zuende



// Funktionen

void dislinini(double xmax, double Solitonenzahl)
{
	dislin::winsiz(1600,1200);
	dislin::metafl("XWIN");
	dislin::scrmod("reverse");
	dislin::disini();
	dislin::name("Ort x","X");
	dislin::name("Amplitude u","Y");
	dislin::labdig(1,"X");
	dislin::labdig(1,"Y");
	dislin::graf(-xmax/2,xmax/2,-xmax/2,xmax/10,-5 + 3.55* Solitonenzahl-2.75*pow(Solitonenzahl,2),1,-5 + 3.55* Solitonenzahl-2.75*pow(Solitonenzahl,2),-(-5 + 3.55* Solitonenzahl-2.75*pow(Solitonenzahl,2))/10);	
//einstellung vom Graph mit angepassten Gren

}


// Definiert den Sekans Hyperbolicus
double sech(double x)
{
	return ( 2 / ( exp(x) + exp(-x) ) );
}



// Setzt die Startbedingungen
double Startbedingungen(double xposition, int solitonenzahl)
{
	return ( - solitonenzahl * (solitonenzahl + 1) * sech(xposition)*sech(xposition));
}


double ersterzeitschritt(double uxt[xschritte], int i)
{

// periodische Rnder
	int jp2 = i + 2;
	if(jp2 > xschritte -1)
	{
		jp2 = jp2 - xschritte;
	}

	int jp1 = i + 1;
	if(jp1 > xschritte -1)
	{
		jp1 = jp1 - xschritte;
	}

	int jm1 = i - 1;
	if(jm1 < 0 )
	{
		jm1 = jm1 + xschritte;
	}

	int jm2 = i - 2;
	if(jm2 < 0 )
	{
		jm2 = jm2 + xschritte;
	}
/*
//feste Rnder
int jp2 = i + 2;
	if(jp2 > xschritte -1)
	{
		jp2 = xschritte -1;
	}

	int jp1 = i + 1;
	if(jp1 > xschritte -1)
	{
		jp1 = xschritte -1;
	}

	int jm1 = i - 1;
	if(jm1 < 0 )
	{
		jm1 = 0;
	}

	int jm2 = i - 2;
	if(jm2 < 0 )
	{
		jm2 = 0;
	}
*/
	// Berechnung des Gitterpunktes 
	return (uxt[i] +dt * ( 6 * uxt[i] * (( uxt[jp1] - uxt[jm1]) / 2 / dx ) - (uxt[jp2] - 2* uxt[jp1] + 2 * uxt[jm1] - uxt[jm2] ) / (2 * dx * dx * dx)));

}


double zeitschritt(double uxt[xschritte], double uxtmdt[xschritte], int i)
{

// periodische rnder
	int jp2 = i + 2;
	if(jp2 > xschritte -1)
	{
		jp2 = jp2 - xschritte;
	}

	int jp1 = i + 1;
	if(jp1 > xschritte -1)
	{
		jp1 = jp1 - xschritte;
	}

	int jm1 = i - 1;
	if(jm1 < 0 )
	{
		jm1 = jm1 + xschritte;
	}

	int jm2 = i - 2;
	if(jm2 < 0 )
	{
		jm2 = jm2 + xschritte;
	}

/*
//Feste Rnder
	int jp2 = i + 2;
	if(jp2 > xschritte -1)
	{
		jp2 = xschritte -1;
	}

	int jp1 = i + 1;
	if(jp1 > xschritte -1)
	{
		jp1 = xschritte -1;
	}

	int jm1 = i - 1;
	if(jm1 < 0 )
	{
		jm1 = 0;
	}

	int jm2 = i - 2;
	if(jm2 < 0 )
	{
		jm2 = 0;
	}
*/

	// Berechnung des Gitterpunktes 

	return ( 1 / pow(dx,3) * ( pow(dx,3) * uxtmdt[i] + 2 * dt * dx * dx * ( uxt[jp1] + uxt[i] + uxt[jm1]) * (uxt[jp1] - uxt[jm1] ) + dt * (2* uxt[jp1] - 2 * uxt[jm1] - uxt[jp2] + uxt[jm2] )));
	}


	double analytisch(double Zeit, double Ort)   //analytische Lsung nach Theorie
	{
		return ( - 12 * ( 3 + 4 * cosh(2* Ort - 8 * Zeit) + cosh(4 * Ort - 64 * Zeit) ) / (( 3 * cosh(Ort - 28 * Zeit) + cosh( 3 * Ort - 36 * Zeit))*( 3 * cosh(Ort - 28 * Zeit) + cosh( 3 * Ort - 36 * Zeit))));
	}